/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TURNO                                                     */
/* Tabela : TURNO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 16/09/2009 - Vincius Soares Rosa                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TURNO' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATU_TURNO
GO

CREATE TRIGGER DTULTATU_TURNO
ON TURNO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TURNO', null, 'NRTURNO=' + NRTURNO + ';',                                GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE TURNO
      SET DTULTATUTURN = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TURNO.NRTURNO,0)     = ISNULL(INSERTED.NRTURNO,0))     AND
            (ISNULL(TURNO.DSTURNO,0)   = ISNULL(INSERTED.DSTURNO,0))   AND
            (ISNULL(TURNO.HRFIMTURNO,0) = ISNULL(INSERTED.HRFIMTURNO,0)) AND
            (ISNULL(TURNO.HRINITURNO,0) = ISNULL(INSERTED.HRINITURNO,0)) AND
            (ISNULL(TURNO.SGTURNO,0) = ISNULL(INSERTED.SGTURNO,0)) AND
            (ISNULL(TURNO.HRINIDECOL,0) = ISNULL(INSERTED.HRINIDECOL,0)) AND
            (ISNULL(TURNO.HRFINDECOL,0) = ISNULL(INSERTED.HRFINDECOL,0)) AND
            (ISNULL(TURNO.IDTIPOTURNO,0) = ISNULL(INSERTED.IDTIPOTURNO,0));
   END;
END;
GO
